package xyz.lychee.lagfixer.libs.adventure.text;

import java.util.Objects;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.ApiStatus.NonExtendable;
import xyz.lychee.lagfixer.libs.examination.Examinable;

@NonExtendable
public interface TranslationArgument extends TranslationArgumentLike, Examinable {
   static @NotNull TranslationArgument bool(final boolean value) {
      return new TranslationArgumentImpl(value);
   }

   static @NotNull TranslationArgument numeric(final @NotNull Number value) {
      return new TranslationArgumentImpl(Objects.requireNonNull(value, "value"));
   }

   static @NotNull TranslationArgument component(final @NotNull ComponentLike value) {
      return (TranslationArgument)(value instanceof TranslationArgumentLike ? ((TranslationArgumentLike)value).asTranslationArgument() : new TranslationArgumentImpl(Objects.requireNonNull(((ComponentLike)Objects.requireNonNull(value, "value")).asComponent(), "value.asComponent()")));
   }

   @NotNull Object value();

   default @NotNull TranslationArgument asTranslationArgument() {
      return this;
   }
}
